<template>
  <div>
    <v-card class="mx-auto" width="30vw" height="106.6vh" id="security">
      <v-row>
        <v-col cols="3" class="mr-2">
          <v-btn icon>
            <v-icon @click="calDialog = true" class="button" medium
              >mdi-calendar</v-icon
            >
          </v-btn>
          <v-btn icon>
            <v-icon @click="mapDialog = true" class="button" medium
              >mdi-map</v-icon
            >
          </v-btn>
        </v-col>
        <h4>{{ getFormatedDate() }}</h4>
      </v-row>
      <v-row justify="center">
        <h1>ציר אבטחתי</h1>
      </v-row>
      <v-row align="center">
        <v-col class="d-flex mx-auto" cols="12" sm="6">
          <v-select
            v-model="selectedCity"
            :items="items"
            label="אזור מוצג"
          ></v-select>
        </v-col>
      </v-row>
      <v-list id="reports" height="50vh">
        <report
          class="mx-4 mb-3"
          id="line"
          v-for="(report, index) in filteredReportsDate"
          :key="index"
          :data="report"
        ></report>
      </v-list>
    </v-card>

    <v-dialog
      v-model="this.mapDialog"
      @click:outside="mapDialog = false"
      id="mapDialog"
    >
      <v-card height="90vh" id="mapCard">
        <v-row>
          <v-btn icon class="mt-5 mr-5" @click="mapDialog = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
          <iframe
            height="800vh"
            width="1780vw"
            class="mr-12"
            src="http://maps-legend-git-tmzmap1.apps.openforce.openforce.biz/#/MapAmatz"
          ></iframe>
        </v-row>
      </v-card>
    </v-dialog>

    <v-dialog
      @click:outside="calDialog = false"
      id="dialog"
      v-model="this.calDialog"
      width="20vw"
    >
      <v-card fill-height height="49vh" width="20vw" id="calCard">
        <v-btn icon class="mt-5 mr-5" @click="calDialog = false">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <h1 align="center">בחירת תאריך</h1>
        <v-row class="align-end justify-end ml-16">
          <date-picker
            class="mt-10"
            @dayclick="dayClicked"
            v-model="selectedDate"
            mode="date"
            id="datePicker"
          ></date-picker>
        </v-row>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import Report from "./Report";
import api from "../api";
import dateFormat from "date-format";

export default {
  name: "Security",
  components: {
    Report
  },
  created() {
    this.getReports();
  },
  watch: {
    selectedDate: function() {
      this.filteredReportsDate();
    }
  },
  data() {
    return {
      items: [
        "הצג הכל",
        "ברונקס",
        "ברוקלין",
        "מנהטן",
        "קווינס",
        "סטייטן איילנד"
      ],
      reports: [],
      mapDialog: false,
      calDialog: false,
      selectedDate: new Date(),
      selectedCity: ""
    };
  },
  methods: {
    getReports() {
      api.reports.allReports().then(res => {
        this.reports = res.data;
      });
    },
    dayClicked() {
      this.calDialog = false;
    },
    getFormatedDate() {
      return dateFormat.asString("dd/MM/yy", this.selectedDate);
    }
  },
  computed: {
    filteredReportsArea() {
      if (this.selectedCity === "" || this.selectedCity === "הצג הכל") {
        return this.reports;
      } else {
        const reportsToFilter = this.reports.filter(
          report => report.ev_area === this.selectedCity
        );
        return reportsToFilter;
      }
    },
    filteredReportsDate() {
      const reportsToFilter = this.filteredReportsArea;
      const reports = reportsToFilter.filter(
        report =>
          dateFormat.asString("dd/MM/yy", new Date(report["ev_time"])) ==
          dateFormat.asString("dd/MM/yy", this.selectedDate)
      );
      return reports;
    }
  }
};
</script>

<style scoped>
#reports {
  height: 25vh;
  overflow-y: auto;
  background-color: #dfeeea;
  opacity: 0.95;
}

#security {
  background-color: #dfeeea;
  opacity: 0.95;
}

#line {
  margin-bottom: 2%;
}

h1 {
  color: #38919b;
}

.button {
  color: #a7c4bcc4;
}

#title {
  height: 10vh;
}

#mapDialog {
  z-index: 55;
}

#mapCard {
  background-color: #dfeeea;
  opacity: 0.95;
}

h4 {
  color: rgba(0, 0, 0, 0.623);
  margin-right: 55%;
  padding-top: 3.5%;
}

#calCard {
  background-color: #dfeeea;
  opacity: 0.95;
}

#datePicker {
  direction: ltr;
}
</style>
